#include <mpi.h>
#include <stdio.h>

main(int argc, char* argv[]) {
  int rank,size;
  MPI_Status status;
  int square[200],i;
  double norm[100];
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  if (rank==1) {
    for(i=0;i<200;++i) {
      square[i]=i*i;
    }
    MPI_Send(square,200,MPI_INT,3,99,MPI_COMM_WORLD);
    MPI_Recv(norm,100,MPI_DOUBLE,3,86,MPI_COMM_WORLD,&status);
    printf("P:%d 22.0/53.0=%f\n",rank,norm[2]);
  }
  if(rank==3) {
    for(i=20;i<=119;++i) {
      norm[i-20]=(double) i/53.0;
    }
    MPI_Send(norm,100,MPI_DOUBLE,1,86,MPI_COMM_WORLD);
    MPI_Recv(square,200,MPI_INT,1,99,MPI_COMM_WORLD,&status);
    printf("P:%d square of 3 is %d\n",rank,square[3]);
  }
  MPI_Finalize();
} 
