#include <mpi.h>
#include <stdio.h>

main(int argc, char* argv[]) {
  int rank,size;
  MPI_Status status;
  int dim[2],period[2],reorder;
  double sum;
  MPI_Comm GRID;
  int nay[4],x,i,num,count;
  static int hold[8]={-27,-4,31,16,20,13,49,1};
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  x=hold[rank];
  dim[0]=2; dim[1]=4;
  period[1]=period[0]=0;
  reorder=1;
  MPI_Cart_create(MPI_COMM_WORLD,2,dim,period,reorder,&GRID);
  MPI_Cart_shift(GRID,0,1,&nay[0],&nay[1]);
  MPI_Cart_shift(GRID,1,1,&nay[2],&nay[3]);
  for (i=0;i<4;++i) {
     if (nay[i]!=MPI_PROC_NULL)
       MPI_Send(&x,1,MPI_INT,nay[i],66,MPI_COMM_WORLD);
  }
  sum=(double)x;
  count=1;
  for (i=0;i<4;++i) {
    if (nay[i]!=MPI_PROC_NULL) {
      MPI_Recv(&num,1,MPI_INT,nay[i],66,MPI_COMM_WORLD,&status);
      sum+=num;
      ++count;
    }
  }
  printf("P:%d my average is %f\n",rank,sum/count);
  MPI_Finalize();
}
