#include <mpi.h>

main(int argc, char* argv[]) {
  int rank,size;
  MPI_Status status;
  int eleven[50],i;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  if (rank==1) {
    for(i=0;i<50;++i) {
      eleven[i]=11;
    }
    MPI_Send(eleven,50,MPI_INT,2,1001,MPI_COMM_WORLD);
    }
  else if(rank==2) {
    MPI_Recv(eleven,50,MPI_INT,MPI_ANY_SOURCE, MPI_ANY_TAG,MPI_COMM_WORLD,
        &status);
    printf("P %d Message from proc %d\n",rank,status.MPI_SOURCE);
    printf("P %d Message has tag %d\n",rank,status.MPI_TAG);
    printf("P %d 13th array element is %d\n",rank,eleven[13]);
  }
  MPI_Finalize();
} 
