#include <mpi.h>
#include <stdio.h>
#include <math.h>

void raise(int x);
void fac(int x);
void summer(int x); 

main(int argc, char* argv[]) {
  int rank,size;
  MPI_Status status;
  int num,who,i;
  static int value[3]={10,5,33};
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  if (rank==3) {
    for(i=0;i<3;++i) {
      MPI_Recv(&num,1,MPI_INT,MPI_ANY_SOURCE,88,MPI_COMM_WORLD,&status);
      who=status.MPI_SOURCE;
      if (who==0) {
        raise(num);
        }
      else if (who==1) {
        fac(num);
        }
      else {
        summer(num);
        }
      }
    }
  else {
    num=value[rank];
    MPI_Send(&num,1,MPI_INT,3,88,MPI_COMM_WORLD);
  }
  MPI_Finalize();
}

void raise(int x) {
  printf("2 to the %d power=%f\n",x,pow(2.0,x));
}

void fac(int x) {
  int i,res;
  res=1;
  for(i=1;i<=x;++i) {
    res*=i;
  }
  printf("The fatorial of %d is %d\n",x,res);
}

void summer(int x) {
  int res;
  res=x*(x+1)/2;
  printf("The sum of the integers up to %d is %d\n",x,res);
}
   
