#include <mpi.h>
#include <stdio.h>

main(int argc, char* argv[]) {
  int rank,size;
  MPI_Status status;
  int i,x,max;
  double norm,sum;
  static int hold[8]={-27,-4,31,16,20,13,49,1}; 
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  x=hold[rank];
  MPI_Reduce(&x,&max,1,MPI_INT,MPI_MAX,5,MPI_COMM_WORLD);
  if (rank==5) {
    for(i=0;i<8;++i) {
      MPI_Send(&max,1,MPI_INT,i,359,MPI_COMM_WORLD);
    }
  }
  MPI_Recv(&max,1,MPI_INT,5,359,MPI_COMM_WORLD,&status);
  norm=x/(double) max;
  sum=0.0;
  MPI_Reduce(&norm,&sum,1,MPI_DOUBLE,MPI_SUM,2,MPI_COMM_WORLD);
  if (rank==2) {
    printf("P:%d normalize sum is %f\n",rank,sum);
  }
  MPI_Finalize();
}

